org.eclipse.jetty.server

## Class Request

- java.lang.Object
- - org.eclipse.jetty.server.Request

- All Implemented Interfaces:
    javax.servlet.http.HttpServletRequest, javax.servlet.ServletRequest
  Direct Known Subclasses:
    Ajp13Request, NestedRequest

      public class Request
      extends java.lang.Object
      implements javax.servlet.http.HttpServletRequest

  Jetty Request.

  Implements `HttpServletRequest` from the `javax.servlet.http` package.

  The standard interface of mostly getters, is extended with setters so that the request is mutable by the handlers that it is passed to. This allows the request object to be as lightweight as possible and not actually implement any significant behavior. For example

  - The `getContextPath()` method will return null, until the request has been passed to a `ContextHandler` which matches the `getPathInfo()` with a context path and calls `setContextPath(String)` as a result.
  - the HTTP session methods will all return null sessions until such time as a request has been passed to a `SessionHandler` which checks for session cookies and enables the ability to create new sessions.
  - The `getServletPath()` method will return null until the request has been passed to a `org.eclipse.jetty.servlet.ServletHandler` and the pathInfo matched against the servlet URL patterns and `setServletPath(String)` called as a result.
  A request instance is created for each `AbstractHttpConnection` accepted by the server and recycled for each HTTP request received via that connection. An effort is made to avoid reparsing headers and cookies that are likely to be the same for requests from the same connection.

  The form content that a request can process is limited to protect from Denial of Service attacks. The size in bytes is limited by `ContextHandler.getMaxFormContentSize()` or if there is no context then the "org.eclipse.jetty.server.Request.maxFormContentSize" `Server` attribute. The number of parameters keys is limited by `ContextHandler.getMaxFormKeys()` or if there is no context then the "org.eclipse.jetty.server.Request.maxFormKeys" `Server` attribute.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AsyncContinuation` | `_async`
    `protected AbstractHttpConnection` | `_connection`

    - ### Fields inherited from interface javax.servlet.http.HttpServletRequest

      `BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Request()`
    `Request(AbstractHttpConnection connection)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addEventListener(java.util.EventListener listener)`
    `void` | `extractParameters()` Extract Parameters from query string and/or form _content.
    `AsyncContext` | `getAsyncContext()`
    `AsyncContinuation` | `getAsyncContinuation()`
    `java.lang.Object` | `getAttribute(java.lang.String name)`
    `java.util.Enumeration` | `getAttributeNames()`
    `Attributes` | `getAttributes()`
    `Authentication` | `getAuthentication()` Get the authentication.
    `java.lang.String` | `getAuthType()`
    `java.lang.String` | `getCharacterEncoding()`
    `AbstractHttpConnection` | `getConnection()`
    `int` | `getContentLength()`
    `long` | `getContentRead()`
    `java.lang.String` | `getContentType()`
    `ContextHandler.Context` | `getContext()`
    `java.lang.String` | `getContextPath()`
    `javax.servlet.http.Cookie[]` | `getCookies()`
    `long` | `getDateHeader(java.lang.String name)`
    `DispatcherType` | `getDispatcherType()`
    `long` | `getDispatchTime()` Get timestamp of the request dispatch
    `java.lang.String` | `getHeader(java.lang.String name)`
    `java.util.Enumeration` | `getHeaderNames()`
    `java.util.Enumeration` | `getHeaders(java.lang.String name)`
    `int` | `getInputState()`
    `javax.servlet.ServletInputStream` | `getInputStream()`
    `int` | `getIntHeader(java.lang.String name)`
    `java.lang.String` | `getLocalAddr()`
    `java.util.Locale` | `getLocale()`
    `java.util.Enumeration` | `getLocales()`
    `java.lang.String` | `getLocalName()`
    `int` | `getLocalPort()`
    `java.lang.String` | `getMethod()`
    `java.lang.String` | `getParameter(java.lang.String name)`
    `java.util.Map` | `getParameterMap()`
    `java.util.Enumeration` | `getParameterNames()`
    `MultiMap<java.lang.String>` | `getParameters()`
    `java.lang.String[]` | `getParameterValues(java.lang.String name)`
    `java.lang.String` | `getPathInfo()`
    `java.lang.String` | `getPathTranslated()`
    `java.lang.String` | `getProtocol()`
    `java.lang.String` | `getQueryEncoding()`
    `java.lang.String` | `getQueryString()`
    `java.io.BufferedReader` | `getReader()`
    `java.lang.String` | `getRealPath(java.lang.String path)`
    `java.lang.String` | `getRemoteAddr()`
    `java.lang.String` | `getRemoteHost()`
    `int` | `getRemotePort()`
    `java.lang.String` | `getRemoteUser()`
    `static Request` | `getRequest(javax.servlet.http.HttpServletRequest request)`
    `javax.servlet.RequestDispatcher` | `getRequestDispatcher(java.lang.String path)`
    `java.lang.String` | `getRequestedSessionId()`
    `java.lang.String` | `getRequestURI()`
    `java.lang.StringBuffer` | `getRequestURL()`
    `UserIdentity` | `getResolvedUserIdentity()`
    `Response` | `getResponse()`
    `java.lang.StringBuilder` | `getRootURL()` Reconstructs the URL the client used to make the request.
    `java.lang.String` | `getScheme()`
    `java.lang.String` | `getServerName()`
    `int` | `getServerPort()`
    `javax.servlet.ServletContext` | `getServletContext()`
    `java.lang.String` | `getServletName()`
    `java.lang.String` | `getServletPath()`
    `javax.servlet.ServletResponse` | `getServletResponse()`
    `javax.servlet.http.HttpSession` | `getSession()`
    `javax.servlet.http.HttpSession` | `getSession(boolean create)`
    `SessionManager` | `getSessionManager()`
    `long` | `getTimeStamp()` Get Request TimeStamp
    `Buffer` | `getTimeStampBuffer()` Get Request TimeStamp
    `HttpURI` | `getUri()`
    `UserIdentity` | `getUserIdentity()`
    `UserIdentity.Scope` | `getUserIdentityScope()`
    `java.security.Principal` | `getUserPrincipal()`
    `boolean` | `isAsyncSupported()`
    `boolean` | `isHandled()`
    `boolean` | `isRequestedSessionIdFromCookie()`
    `boolean` | `isRequestedSessionIdFromUrl()`
    `boolean` | `isRequestedSessionIdFromURL()`
    `boolean` | `isRequestedSessionIdValid()`
    `boolean` | `isSecure()`
    `boolean` | `isUserInRole(java.lang.String role)`
    `void` | `mergeQueryString(java.lang.String query)` Merge in a new query string.
    `javax.servlet.http.HttpSession` | `recoverNewSession(java.lang.Object key)`
    `protected void` | `recycle()`
    `void` | `removeAttribute(java.lang.String name)`
    `void` | `removeEventListener(java.util.EventListener listener)`
    `void` | `saveNewSession(java.lang.Object key, javax.servlet.http.HttpSession session)`
    `void` | `setAsyncSupported(boolean supported)`
    `void` | `setAttribute(java.lang.String name, java.lang.Object value)`
    `void` | `setAttributes(Attributes attributes)`
    `void` | `setAuthentication(Authentication authentication)` Set the authentication.
    `void` | `setCharacterEncoding(java.lang.String encoding)`
    `void` | `setCharacterEncodingUnchecked(java.lang.String encoding)`
    `protected void` | `setConnection(AbstractHttpConnection connection)`
    `void` | `setContentType(java.lang.String contentType)`
    `void` | `setContext(ContextHandler.Context context)` Set request context
    `void` | `setContextPath(java.lang.String contextPath)` Sets the "context path" for this request
    `void` | `setCookies(javax.servlet.http.Cookie[] cookies)`
    `void` | `setDispatcherType(DispatcherType type)`
    `void` | `setDispatchTime(long value)` Set timetstamp of request dispatch
    `void` | `setHandled(boolean h)`
    `void` | `setMethod(java.lang.String method)`
    `void` | `setParameters(MultiMap<java.lang.String> parameters)`
    `void` | `setPathInfo(java.lang.String pathInfo)`
    `void` | `setProtocol(java.lang.String protocol)`
    `void` | `setQueryEncoding(java.lang.String queryEncoding)` Set the character encoding used for the query string.
    `void` | `setQueryString(java.lang.String queryString)`
    `void` | `setRemoteAddr(java.lang.String addr)`
    `void` | `setRemoteHost(java.lang.String host)`
    `void` | `setRequestedSessionId(java.lang.String requestedSessionId)`
    `void` | `setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)`
    `void` | `setRequestURI(java.lang.String requestURI)`
    `void` | `setScheme(java.lang.String scheme)`
    `void` | `setServerName(java.lang.String host)`
    `void` | `setServerPort(int port)`
    `void` | `setServletPath(java.lang.String servletPath)`
    `void` | `setSession(javax.servlet.http.HttpSession session)`
    `void` | `setSessionManager(SessionManager sessionManager)`
    `void` | `setTimeStamp(long ts)`
    `void` | `setUri(HttpURI uri)`
    `void` | `setUserIdentityScope(UserIdentity.Scope scope)`
    `AsyncContext` | `startAsync()`
    `AsyncContext` | `startAsync(javax.servlet.ServletRequest servletRequest, javax.servlet.ServletResponse servletResponse)`
    `boolean` | `takeNewContext()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _async

          protected final AsyncContinuation _async

    - #### _connection

          protected AbstractHttpConnection _connection

  - ### Constructor Detail

    - #### Request

          public Request()

    - #### Request

          public Request(AbstractHttpConnection connection)

  - ### Method Detail

    - #### getRequest

          public static Request getRequest(javax.servlet.http.HttpServletRequest request)

    - #### addEventListener

          public void addEventListener(java.util.EventListener listener)

    - #### extractParameters

          public void extractParameters()

      Extract Parameters from query string and/or form _content.

    - #### getAsyncContext

          public AsyncContext getAsyncContext()

    - #### getAsyncContinuation

          public AsyncContinuation getAsyncContinuation()

    - #### getAttribute

          public java.lang.Object getAttribute(java.lang.String name)

      Specified by:
        `getAttribute` in interface `javax.servlet.ServletRequest`

    - #### getAttributeNames

          public java.util.Enumeration getAttributeNames()

      Specified by:
        `getAttributeNames` in interface `javax.servlet.ServletRequest`

    - #### getAttributes

          public Attributes getAttributes()

    - #### getAuthentication

          public Authentication getAuthentication()

      Get the authentication.
      Returns:
        the authentication

    - #### getAuthType

          public java.lang.String getAuthType()

      Specified by:
        `getAuthType` in interface `javax.servlet.http.HttpServletRequest`

    - #### getCharacterEncoding

          public java.lang.String getCharacterEncoding()

      Specified by:
        `getCharacterEncoding` in interface `javax.servlet.ServletRequest`

    - #### getConnection

          public AbstractHttpConnection getConnection()

      Returns:
        Returns the connection.

    - #### getContentLength

          public int getContentLength()

      Specified by:
        `getContentLength` in interface `javax.servlet.ServletRequest`

    - #### getContentRead

          public long getContentRead()

    - #### getContentType

          public java.lang.String getContentType()

      Specified by:
        `getContentType` in interface `javax.servlet.ServletRequest`

    - #### getContext

          public ContextHandler.Context getContext()

      Returns:
        The current `context` used for this request, or `null` if `setContext(org.eclipse.jetty.server.handler.ContextHandler.Context)` has not yet been called.

    - #### getContextPath

          public java.lang.String getContextPath()

      Specified by:
        `getContextPath` in interface `javax.servlet.http.HttpServletRequest`

    - #### getCookies

          public javax.servlet.http.Cookie[] getCookies()

      Specified by:
        `getCookies` in interface `javax.servlet.http.HttpServletRequest`

    - #### getDateHeader

          public long getDateHeader(java.lang.String name)

      Specified by:
        `getDateHeader` in interface `javax.servlet.http.HttpServletRequest`

    - #### getDispatcherType

          public DispatcherType getDispatcherType()

    - #### getHeader

          public java.lang.String getHeader(java.lang.String name)

      Specified by:
        `getHeader` in interface `javax.servlet.http.HttpServletRequest`

    - #### getHeaderNames

          public java.util.Enumeration getHeaderNames()

      Specified by:
        `getHeaderNames` in interface `javax.servlet.http.HttpServletRequest`

    - #### getHeaders

          public java.util.Enumeration getHeaders(java.lang.String name)

      Specified by:
        `getHeaders` in interface `javax.servlet.http.HttpServletRequest`

    - #### getInputState

          public int getInputState()

      Returns:
        Returns the inputState.

    - #### getInputStream

          public javax.servlet.ServletInputStream getInputStream()
                                                          throws java.io.IOException

      Specified by:
        `getInputStream` in interface `javax.servlet.ServletRequest`
      Throws:
        `java.io.IOException`

    - #### getIntHeader

          public int getIntHeader(java.lang.String name)

      Specified by:
        `getIntHeader` in interface `javax.servlet.http.HttpServletRequest`

    - #### getLocalAddr

          public java.lang.String getLocalAddr()

      Specified by:
        `getLocalAddr` in interface `javax.servlet.ServletRequest`

    - #### getLocale

          public java.util.Locale getLocale()

      Specified by:
        `getLocale` in interface `javax.servlet.ServletRequest`

    - #### getLocales

          public java.util.Enumeration getLocales()

      Specified by:
        `getLocales` in interface `javax.servlet.ServletRequest`

    - #### getLocalName

          public java.lang.String getLocalName()

      Specified by:
        `getLocalName` in interface `javax.servlet.ServletRequest`

    - #### getLocalPort

          public int getLocalPort()

      Specified by:
        `getLocalPort` in interface `javax.servlet.ServletRequest`

    - #### getMethod

          public java.lang.String getMethod()

      Specified by:
        `getMethod` in interface `javax.servlet.http.HttpServletRequest`

    - #### getParameter

          public java.lang.String getParameter(java.lang.String name)

      Specified by:
        `getParameter` in interface `javax.servlet.ServletRequest`

    - #### getParameterMap

          public java.util.Map getParameterMap()

      Specified by:
        `getParameterMap` in interface `javax.servlet.ServletRequest`

    - #### getParameterNames

          public java.util.Enumeration getParameterNames()

      Specified by:
        `getParameterNames` in interface `javax.servlet.ServletRequest`

    - #### getParameters

          public MultiMap<java.lang.String> getParameters()

      Returns:
        Returns the parameters.

    - #### getParameterValues

          public java.lang.String[] getParameterValues(java.lang.String name)

      Specified by:
        `getParameterValues` in interface `javax.servlet.ServletRequest`

    - #### getPathInfo

          public java.lang.String getPathInfo()

      Specified by:
        `getPathInfo` in interface `javax.servlet.http.HttpServletRequest`

    - #### getPathTranslated

          public java.lang.String getPathTranslated()

      Specified by:
        `getPathTranslated` in interface `javax.servlet.http.HttpServletRequest`

    - #### getProtocol

          public java.lang.String getProtocol()

      Specified by:
        `getProtocol` in interface `javax.servlet.ServletRequest`

    - #### getQueryEncoding

          public java.lang.String getQueryEncoding()

    - #### getQueryString

          public java.lang.String getQueryString()

      Specified by:
        `getQueryString` in interface `javax.servlet.http.HttpServletRequest`

    - #### getReader

          public java.io.BufferedReader getReader()
                                           throws java.io.IOException

      Specified by:
        `getReader` in interface `javax.servlet.ServletRequest`
      Throws:
        `java.io.IOException`

    - #### getRealPath

          public java.lang.String getRealPath(java.lang.String path)

      Specified by:
        `getRealPath` in interface `javax.servlet.ServletRequest`

    - #### getRemoteAddr

          public java.lang.String getRemoteAddr()

      Specified by:
        `getRemoteAddr` in interface `javax.servlet.ServletRequest`

    - #### getRemoteHost

          public java.lang.String getRemoteHost()

      Specified by:
        `getRemoteHost` in interface `javax.servlet.ServletRequest`

    - #### getRemotePort

          public int getRemotePort()

      Specified by:
        `getRemotePort` in interface `javax.servlet.ServletRequest`

    - #### getRemoteUser

          public java.lang.String getRemoteUser()

      Specified by:
        `getRemoteUser` in interface `javax.servlet.http.HttpServletRequest`

    - #### getRequestDispatcher

          public javax.servlet.RequestDispatcher getRequestDispatcher(java.lang.String path)

      Specified by:
        `getRequestDispatcher` in interface `javax.servlet.ServletRequest`

    - #### getRequestedSessionId

          public java.lang.String getRequestedSessionId()

      Specified by:
        `getRequestedSessionId` in interface `javax.servlet.http.HttpServletRequest`

    - #### getRequestURI

          public java.lang.String getRequestURI()

      Specified by:
        `getRequestURI` in interface `javax.servlet.http.HttpServletRequest`

    - #### getRequestURL

          public java.lang.StringBuffer getRequestURL()

      Specified by:
        `getRequestURL` in interface `javax.servlet.http.HttpServletRequest`

    - #### getResponse

          public Response getResponse()

    - #### getRootURL

          public java.lang.StringBuilder getRootURL()

      Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and, but it does not include a path.

      Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append path and query parameters. This method is useful for creating redirect messages and for reporting errors.

      Returns:
        "scheme://host:port"

    - #### getScheme

          public java.lang.String getScheme()

      Specified by:
        `getScheme` in interface `javax.servlet.ServletRequest`

    - #### getServerName

          public java.lang.String getServerName()

      Specified by:
        `getServerName` in interface `javax.servlet.ServletRequest`

    - #### getServerPort

          public int getServerPort()

      Specified by:
        `getServerPort` in interface `javax.servlet.ServletRequest`

    - #### getServletContext

          public javax.servlet.ServletContext getServletContext()

    - #### getServletName

          public java.lang.String getServletName()

    - #### getServletPath

          public java.lang.String getServletPath()

      Specified by:
        `getServletPath` in interface `javax.servlet.http.HttpServletRequest`

    - #### getServletResponse

          public javax.servlet.ServletResponse getServletResponse()

    - #### getSession

          public javax.servlet.http.HttpSession getSession()

      Specified by:
        `getSession` in interface `javax.servlet.http.HttpServletRequest`

    - #### getSession

          public javax.servlet.http.HttpSession getSession(boolean create)

      Specified by:
        `getSession` in interface `javax.servlet.http.HttpServletRequest`

    - #### getSessionManager

          public SessionManager getSessionManager()

      Returns:
        Returns the sessionManager.

    - #### getTimeStamp

          public long getTimeStamp()

      Get Request TimeStamp
      Returns:
        The time that the request was received.

    - #### getTimeStampBuffer

          public Buffer getTimeStampBuffer()

      Get Request TimeStamp
      Returns:
        The time that the request was received.

    - #### getUri

          public HttpURI getUri()

      Returns:
        Returns the uri.

    - #### getUserIdentity

          public UserIdentity getUserIdentity()

    - #### getResolvedUserIdentity

          public UserIdentity getResolvedUserIdentity()

      Returns:
        The resolved user Identity, which may be null if the `Authentication` is not `Authentication.User` (eg. `Authentication.Deferred`).

    - #### getUserIdentityScope

          public UserIdentity.Scope getUserIdentityScope()

    - #### getUserPrincipal

          public java.security.Principal getUserPrincipal()

      Specified by:
        `getUserPrincipal` in interface `javax.servlet.http.HttpServletRequest`

    - #### getDispatchTime

          public long getDispatchTime()

      Get timestamp of the request dispatch
      Returns:
        timestamp

    - #### isHandled

          public boolean isHandled()

    - #### isAsyncSupported

          public boolean isAsyncSupported()

    - #### isRequestedSessionIdFromCookie

          public boolean isRequestedSessionIdFromCookie()

      Specified by:
        `isRequestedSessionIdFromCookie` in interface `javax.servlet.http.HttpServletRequest`

    - #### isRequestedSessionIdFromUrl

          public boolean isRequestedSessionIdFromUrl()

      Specified by:
        `isRequestedSessionIdFromUrl` in interface `javax.servlet.http.HttpServletRequest`

    - #### isRequestedSessionIdFromURL

          public boolean isRequestedSessionIdFromURL()

      Specified by:
        `isRequestedSessionIdFromURL` in interface `javax.servlet.http.HttpServletRequest`

    - #### isRequestedSessionIdValid

          public boolean isRequestedSessionIdValid()

      Specified by:
        `isRequestedSessionIdValid` in interface `javax.servlet.http.HttpServletRequest`

    - #### isSecure

          public boolean isSecure()

      Specified by:
        `isSecure` in interface `javax.servlet.ServletRequest`

    - #### isUserInRole

          public boolean isUserInRole(java.lang.String role)

      Specified by:
        `isUserInRole` in interface `javax.servlet.http.HttpServletRequest`

    - #### recoverNewSession

          public javax.servlet.http.HttpSession recoverNewSession(java.lang.Object key)

    - #### recycle

          protected void recycle()

    - #### removeAttribute

          public void removeAttribute(java.lang.String name)

      Specified by:
        `removeAttribute` in interface `javax.servlet.ServletRequest`

    - #### removeEventListener

          public void removeEventListener(java.util.EventListener listener)

    - #### saveNewSession

          public void saveNewSession(java.lang.Object key,
                            javax.servlet.http.HttpSession session)

    - #### setAsyncSupported

          public void setAsyncSupported(boolean supported)

    - #### setAttribute

          public void setAttribute(java.lang.String name,
                          java.lang.Object value)

      Specified by:
        `setAttribute` in interface `javax.servlet.ServletRequest`

    - #### setAttributes

          public void setAttributes(Attributes attributes)

    - #### setAuthentication

          public void setAuthentication(Authentication authentication)

      Set the authentication.
      Parameters:
        `authentication` - the authentication to set

    - #### setCharacterEncoding

          public void setCharacterEncoding(java.lang.String encoding)
                                    throws java.io.UnsupportedEncodingException

      Specified by:
        `setCharacterEncoding` in interface `javax.servlet.ServletRequest`
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### setCharacterEncodingUnchecked

          public void setCharacterEncodingUnchecked(java.lang.String encoding)

    - #### setConnection

          protected final void setConnection(AbstractHttpConnection connection)

    - #### setContentType

          public void setContentType(java.lang.String contentType)

    - #### setContext

          public void setContext(ContextHandler.Context context)

      Set request context
      Parameters:
        `context` - context object

    - #### takeNewContext

          public boolean takeNewContext()

      Returns:
        True if this is the first call of `takeNewContext()` since the last `setContext(org.eclipse.jetty.server.handler.ContextHandler.Context)` call.

    - #### setContextPath

          public void setContextPath(java.lang.String contextPath)

      Sets the "context path" for this request
      See Also:
        `HttpServletRequest.getContextPath()`

    - #### setCookies

          public void setCookies(javax.servlet.http.Cookie[] cookies)

      Parameters:
        `cookies` - The cookies to set.

    - #### setDispatcherType

          public void setDispatcherType(DispatcherType type)

    - #### setHandled

          public void setHandled(boolean h)

    - #### setMethod

          public void setMethod(java.lang.String method)

      Parameters:
        `method` - The method to set.

    - #### setParameters

          public void setParameters(MultiMap<java.lang.String> parameters)

      Parameters:
        `parameters` - The parameters to set.

    - #### setPathInfo

          public void setPathInfo(java.lang.String pathInfo)

      Parameters:
        `pathInfo` - The pathInfo to set.

    - #### setProtocol

          public void setProtocol(java.lang.String protocol)

      Parameters:
        `protocol` - The protocol to set.

    - #### setQueryEncoding

          public void setQueryEncoding(java.lang.String queryEncoding)

      Set the character encoding used for the query string. This call will effect the return of getQueryString and getParamaters. It must be called before any geParameter methods. The request attribute "org.eclipse.jetty.server.server.Request.queryEncoding" may be set as an alternate method of calling setQueryEncoding.
      Parameters:
        `queryEncoding` -

    - #### setQueryString

          public void setQueryString(java.lang.String queryString)

      Parameters:
        `queryString` - The queryString to set.

    - #### setRemoteAddr

          public void setRemoteAddr(java.lang.String addr)

      Parameters:
        `addr` - The address to set.

    - #### setRemoteHost

          public void setRemoteHost(java.lang.String host)

      Parameters:
        `host` - The host to set.

    - #### setRequestedSessionId

          public void setRequestedSessionId(java.lang.String requestedSessionId)

      Parameters:
        `requestedSessionId` - The requestedSessionId to set.

    - #### setRequestedSessionIdFromCookie

          public void setRequestedSessionIdFromCookie(boolean requestedSessionIdCookie)

      Parameters:
        `requestedSessionIdCookie` - The requestedSessionIdCookie to set.

    - #### setRequestURI

          public void setRequestURI(java.lang.String requestURI)

      Parameters:
        `requestURI` - The requestURI to set.

    - #### setScheme

          public void setScheme(java.lang.String scheme)

      Parameters:
        `scheme` - The scheme to set.

    - #### setServerName

          public void setServerName(java.lang.String host)

      Parameters:
        `host` - The host to set.

    - #### setServerPort

          public void setServerPort(int port)

      Parameters:
        `port` - The port to set.

    - #### setServletPath

          public void setServletPath(java.lang.String servletPath)

      Parameters:
        `servletPath` - The servletPath to set.

    - #### setSession

          public void setSession(javax.servlet.http.HttpSession session)

      Parameters:
        `session` - The session to set.

    - #### setSessionManager

          public void setSessionManager(SessionManager sessionManager)

      Parameters:
        `sessionManager` - The sessionManager to set.

    - #### setTimeStamp

          public void setTimeStamp(long ts)

    - #### setUri

          public void setUri(HttpURI uri)

      Parameters:
        `uri` - The uri to set.

    - #### setUserIdentityScope

          public void setUserIdentityScope(UserIdentity.Scope scope)

    - #### setDispatchTime

          public void setDispatchTime(long value)

      Set timetstamp of request dispatch
      Parameters:
        `value` - timestamp

    - #### startAsync

          public AsyncContext startAsync()
                                  throws java.lang.IllegalStateException

      Throws:
        `java.lang.IllegalStateException`

    - #### startAsync

          public AsyncContext startAsync(javax.servlet.ServletRequest servletRequest,
                                javax.servlet.ServletResponse servletResponse)
                                  throws java.lang.IllegalStateException

      Throws:
        `java.lang.IllegalStateException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### mergeQueryString

          public void mergeQueryString(java.lang.String query)

      Merge in a new query string. The query string is merged with the existing parameters and `setParameters(MultiMap)` and `setQueryString(String)` are called with the result. The merge is according to the rules of the servlet dispatch forward method.
      Parameters:
        `query` - The query string to merge into the request.

Copyright © 2013 FuseSource, Corp.. All Rights Reserved.